
From: Oliver Endriss <o.endriss@gmx.de>

av7110_fe_lock_fix() modified in a way that it can be retried after
-ERESTARTSYS

Signed-off-by: Oliver Endriss <o.endriss@gmx.de>
Signed-off-by: Johannes Stezenbach <js@linuxtv.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 drivers/media/dvb/ttpci/av7110.c |    7 ++++---
 1 files changed, 4 insertions(+), 3 deletions(-)

diff -puN drivers/media/dvb/ttpci/av7110.c~dvb-ttpci-make-av7110_fe_lock_fix-retryable drivers/media/dvb/ttpci/av7110.c
--- 25/drivers/media/dvb/ttpci/av7110.c~dvb-ttpci-make-av7110_fe_lock_fix-retryable	Mon Jun 27 15:36:44 2005
+++ 25-akpm/drivers/media/dvb/ttpci/av7110.c	Mon Jun 27 15:36:44 2005
@@ -2038,15 +2038,13 @@ static int av7110_fe_lock_fix(struct av7
 	if (av7110->fe_synced == synced)
 		return 0;
 
-	av7110->fe_synced = synced;
-
 	if (av7110->playing)
 		return 0;
 
 	if (down_interruptible(&av7110->pid_mutex))
 		return -ERESTARTSYS;
 
-	if (av7110->fe_synced) {
+	if (synced) {
 		ret = SetPIDs(av7110, av7110->pids[DMX_PES_VIDEO],
 			av7110->pids[DMX_PES_AUDIO],
 			av7110->pids[DMX_PES_TELETEXT], 0,
@@ -2062,6 +2060,9 @@ static int av7110_fe_lock_fix(struct av7
 		}
 	}
 
+	if (!ret)
+		av7110->fe_synced = synced;
+
 	up(&av7110->pid_mutex);
 	return ret;
 }
_
